//+------------------------------------------------------------------+
//|                                          LuKu_StdDev3Sok_v10.mq4 |
//|                                                             LuKu |
//|                                               http://luku.cz/fx/ |
//+------------------------------------------------------------------+
/*
   Smerodatna odchylka pro trojku
   
   Verze 1.0 (23.1.2012)
     - zakladni naprogramovani
     
     
*/
#property copyright "LuKu"
#property link      "http://luku.cz/fx/"
string Indicator_Name = "DCiklus3Sok_v1";
string ShortName      = "SD3S";

extern string Pair1        = "EURUSDm";
extern string Pair2        = "GBPUSDm";
extern string Pair3        = "EURGBPm";
extern int    StdDevPeriod = 60; // za jakou dobu zpet vypocitavat smerodatnou odchylku
extern int    MaxBarCount  = 1000; // num of calculated bars 0 = all

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 White
#property indicator_color5 Aqua
#property indicator_color6 Lime
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
#property indicator_style6 STYLE_SOLID
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_level1 0
#property indicator_level2 -2
#property indicator_level3 2
int digitsPair1,digitsPair2,digitsPair3,digitsPair4,digitsPair5,digitsPair6;
// buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double StdDev[];
double StdDev1[];
double StdDev2[];
string indname;
double ZeroLine[];
// init
int init(){
   // Name
   indname = StringConcatenate(Indicator_Name, "_", DoubleToStr(Period(),0));
   IndicatorShortName(indname);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buffer1);
   SetIndexLabel(0, "EURUSD");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Buffer2);
   SetIndexLabel(1, "GBPUSD");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Buffer3);
   SetIndexLabel(2, "EURGBP");
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,StdDev);
   SetIndexLabel(3, "SUMM");
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,StdDev1);
   SetIndexLabel(4, "SUMM1");
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,StdDev2);
   SetIndexLabel(5, "SUMM2");
   return(0);
   
   Print(digitsPair1+" jjj");
   Print(digitsPair2);
   Print(digitsPair3);
   Print(digitsPair4);
   Print(digitsPair5);
   Print(digitsPair6);
   
}

// deinit
int deinit(){
  
ObjectDelete("popisPair1"+indname);
ObjectDelete("popisPair2"+indname);
ObjectDelete("popisPair3"+indname);
ObjectDelete("popisPair4"+indname);
ObjectDelete("popisPair5"+indname);
ObjectDelete("popisPair6"+indname);
return(0);
}

// main
int start(){
 int limit;
   int counted_bars = IndicatorCounted();  // kolik jich uz bylo spocitano
   if(counted_bars < 0) return(-1);        // error protection
   if(counted_bars > 0) counted_bars--;    // recounted last bar
   limit = Bars - counted_bars;            // kolik jich mame jeste spocitat
   
   // je pozadovano pocitani pouze urciteho poctu baru (kvuli rychlosti)
   if(MaxBarCount > 0){
     if(limit > MaxBarCount){
       limit = MaxBarCount;


 int WindowNumber = WindowFind(indname);
   if(ObjectFind("popisPair1"+indname)==-1) {
   ObjectCreate("popisPair1"+indname, OBJ_LABEL, WindowNumber, 0, 0);
   ObjectSetText("popisPair1"+indname, Pair1 + "["+digitsPair1+"]", 9, "Arial Bold", Aqua);
   ObjectSet("popisPair1"+indname, OBJPROP_CORNER, 0);
   ObjectSet("popisPair1"+indname, OBJPROP_XDISTANCE, 10);
   ObjectSet("popisPair1"+indname, OBJPROP_YDISTANCE, 20);
   }
   else{
    ObjectSetText("popisPar1"+indname, Pair1, 9, "Arial Bold", Aqua);
   }
   
  
   if(ObjectFind("popisPair2"+indname)==-1) {
   ObjectCreate("popisPair2"+indname, OBJ_LABEL, WindowNumber, 0, 0);
   ObjectSetText("popisPair2"+indname, Pair2 + "["+digitsPair2+"]", 9, "Arial Bold", Red);
   ObjectSet("popisPair2"+indname, OBJPROP_CORNER, 0);
   ObjectSet("popisPair2"+indname, OBJPROP_XDISTANCE, 10);
   ObjectSet("popisPair2"+indname, OBJPROP_YDISTANCE, 35);
      }
   else{
    ObjectSetText("popisPair2"+indname, Pair2, 9, "Arial Bold", Red);
   }
   
  
   if(ObjectFind("popisPair3"+indname)==-1) {
   ObjectCreate("popisPair3"+indname, OBJ_LABEL, WindowNumber, 0, 0);
   ObjectSetText("popisPair3"+indname, Pair3 + "["+digitsPair4+"]", 9, "Arial Bold",Yellow);
   ObjectSet("popisPair3"+indname, OBJPROP_CORNER, 0);
   ObjectSet("popisPair3"+indname, OBJPROP_XDISTANCE, 10);
   ObjectSet("popisPair3"+indname, OBJPROP_YDISTANCE, 50);
      }
   else{
    ObjectSetText("popisPair3"+indname, Pair3, 9, "Arial Bold", Yellow);
  
     }
   }
  
   }
   
   // Main cycle *****************************************************
   double P1, P2, P3;
   for(int i = limit; i>=0; i--){
     // get values
     P1 = getStdDevType(i, StdDevPeriod, Pair1, Period(), MODE_SMA); // EURUSD [>]
     P2 = getStdDevType(i, StdDevPeriod, Pair2, Period(), MODE_SMA); // GBPUSD [<]
     P3 = getStdDevType(i, StdDevPeriod, Pair3, Period(), MODE_SMA); // EURGBP [<]

     /* EUR > USD > GBP > EUR ...kruh
     
        EUR
       /   \
     GBP - USD
     
     */

     Buffer1[i] = P1;        // EURUSD
     Buffer2[i] = P2;//*(-1); // USDGBP > (GBPUSD)
     Buffer3[i] = P3 ;//* (-1); // GBPEUR > (EURGBP)

     // soucet
     // Buffer1[i] = (P1 +P3) - (P2*(-1)); // EU EG proti  GU
     // Buffer2[i] = P1 -((P3*(-1)) + (P2*(-1))); // EU  proti  GU EG
     // Buffer3[i] = P3-((P1*(-1)) + (P2*(-1))); // EG proti EU GU
    // StdDev[i]=(Buffer2[i]+Buffer3[i])-Buffer1[i];
    // StdDev1[i]=(Buffer1[i]+Buffer3[i])-Buffer2[i];
   // StdDev2[i]=-Buffer3[i]-(Buffer2[i]+Buffer1[i]);
   // StdDev2[i]=Buffer1[i]-( (Buffer2[i]* (-1))+(Buffer3[i]* (-1)) );
   }

   return(0);
}

// StdDev method
// function set global variable BBuff, SBuff, DBuff
// direction [1;-1]
double getStdDevType(int i, int period, string Pair, int TimeFrame = 0, int MaMethod = MODE_SMA){
   // moving average
   double MA = iMA(Pair, TimeFrame, period, 0, MaMethod, PRICE_CLOSE, i);
   // standard deviation Buy
   double s = 0.0;
   for(int j = 0; j < period; j++) s += MathPow(MA - iClose(Pair, TimeFrame, j+i),2);      
   double Dev = MathSqrt(s / (period-1));
   if(Dev == 0) Dev = 0.00001; // divide zero protection ;)
   
   return((iClose(Pair, TimeFrame, i) - MA) / Dev);
}



